## rudiments-1.4.2.tar.gz

=== Makefile ===
top_builddir = .

include config.mk

all:
	cd src $(AND) $(MAKE) all

clean:
	cd src $(AND) $(MAKE) clean
	cd test $(AND) $(MAKE) clean
	cd bench $(AND) $(MAKE) clean
	cd examples $(AND) $(MAKE) clean
	$(RMTREE) msvc/setupx86/Release msvc/setupx86/Debug msvc/setupx64/Release msvc/setupx64/Debug

install:
	cd src $(AND) $(MAKE) install
	cd include $(AND) $(MAKE) install
	cd bin $(AND) $(MAKE) install
	cd doc $(AND) $(MAKE) install
	cd man $(AND) $(MAKE) install
	$(MKINSTALLDIRS) $(licensedir)
	$(CP) COPYING $(licensedir)
	$(CHMOD) 0644 $(licensedir)/COPYING
	$(MKINSTALLDIRS) $(libdir)/pkgconfig
	$(CP) rudiments.pc $(libdir)/pkgconfig
	$(CHMOD) 644 $(libdir)/pkgconfig/rudiments.pc

uninstall:
	cd src $(AND) $(MAKE) uninstall
	cd include $(AND) $(MAKE) uninstall
	cd bin $(AND) $(MAKE) uninstall
	cd doc $(AND) $(MAKE) uninstall
	cd man $(AND) $(MAKE) uninstall
	$(RM) $(libdir)/pkgconfig/rudiments.pc
	$(RMTREE) $(licensedir)

distclean: clean
	$(RM) config.mk config.cache config.h config.log config.status features.mk libtool rudiments.pc include/Makefile include/rudiments/private/config.h include/rudiments/private/config.h.in~ bin/rudiments-config src/Makefile msvc/setupx86/rudiments.opensdf msvc/setupx86/rudiments.sdf msvc/setupx86/rudiments.suo msvc/setupx86/setupx86.vdproj msvc/setupx64/rudiments.opensdf msvc/setupx64/rudiments.sdf msvc/setupx64/rudiments.suo msvc/setupx64/setupx64.vdproj configure.lineno test/certificates/config/ca.cnf test/testresults.log
	$(RMTREE) autom4te.cache

cppcheck:
	cppcheck -j4 --enable=warning,performance,portability src > /dev/null

tests:
	cd test $(AND) $(MAKE) tests

tests-clean:
	cd test $(AND) $(MAKE) clean

=== bench/Makefile ===
top_builddir = ..

include ../config.mk

CPPFLAGS = $(BASECPPFLAGS) $(INC)../ $(INC)../include -std=c++11
LIBS=$(RUDIMENTSLIB) $(SOCKETLIBS) $(PTHREADLIB) $(LIBEDITLIBS) $(SSLLIBS) $(GSSLIBS) $(PCRELIBS) $(LIBCURLLIBS) $(NANOSLEEPLIB) $(CLOCKNANOSLEEPLIB) $(CRYPTLIB) $(INETATONLIB) $(BELIB) $(GNULIB) $(CRTLIB) $(DLLIB) $(GETPGIDLIB) $(DEBUGLIB)

PROGS = dictionary \
	dynamicarray \
	forward_list \
	linkedlist \
	list \
	map \
	singlylinkedlist \
	stringbuffer \
	bytebuffer \
	string \
	vector \
	memorypool \
	randomnumber \
	inetsocketclient \
	inetsocketserver \
	bytestring \
	charstring \
	socket

.SUFFIXES: .lo .obj

.cpp.lo:
	$(LTCOMPILE) $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $< $(OUT)$@

.cpp.obj:
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $<

all: $(PROGS)

clean:
	$(LTCLEAN) $(RM) $(PROGS)
	$(LTCLEAN) $(RM) *.exe *.ilk *.idb *.pdb *.manifest *.lo *.o *.obj *.ii

dictionary: dictionary.cpp dictionary.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) dictionary.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

dynamicarray: dynamicarray.cpp dynamicarray.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) dynamicarray.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

forward_list: forward_list.cpp forward_list.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) forward_list.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

linkedlist: linkedlist.cpp linkedlist.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) linkedlist.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

list: list.cpp list.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) list.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

map: map.cpp map.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) map.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

singlylinkedlist: singlylinkedlist.cpp singlylinkedlist.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) singlylinkedlist.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

stringbuffer: stringbuffer.cpp stringbuffer.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) stringbuffer.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

bytebuffer: bytebuffer.cpp bytebuffer.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) bytebuffer.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

string: string.cpp string.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) string.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

vector: vector.cpp vector.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) vector.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

memorypool: memorypool.cpp memorypool.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) memorypool.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

randomnumber: randomnumber.cpp randomnumber.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) randomnumber.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

inetsocketclient: inetsocketclient.cpp inetsocketclient.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) inetsocketclient.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

inetsocketserver: inetsocketserver.cpp inetsocketserver.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) inetsocketserver.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

bytestring: bytestring.cpp bytestring.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) bytestring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

charstring: charstring.cpp charstring.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) charstring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

socket: socket.cpp socket.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) socket.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

=== bin/Makefile ===
top_builddir = ..

include ../config.mk

install:
	$(MKINSTALLDIRS) $(bindir)
	$(CP) rudiments-config $(bindir)
	$(CHMOD) 755 $(bindir)/rudiments-config

uninstall:
	$(RM) $(bindir)/rudiments-config

=== doc/Makefile ===
top_builddir = ..

include ../config.mk

all:

install:
	$(MKINSTALLDIRS) $(docdir)
	$(MKINSTALLDIRS) $(docdir)/css
	$(MKINSTALLDIRS) $(docdir)/classes/html
	$(MKINSTALLDIRS) $(docdir)/features
	$(MKINSTALLDIRS) $(docdir)/programming
	$(MKINSTALLDIRS) $(docdir)/images
	$(CP) installing.html $(docdir)
	$(CP) index.html $(docdir)
	$(CP) css/styles.css $(docdir)/css
	$(CP) classes/html/*.html $(docdir)/classes/html
	$(CP) classes/html/*.png $(docdir)/classes/html
	$(CP) classes/html/*.css $(docdir)/classes/html
	$(CP) classes/html/*.js $(docdir)/classes/html
	$(CP) features/*.html $(docdir)/features
	$(CP) programming/*.html $(docdir)/programming
	$(CP) images/*.png $(docdir)/images
	$(CHMOD) 644 $(docdir)/*.html
	$(CHMOD) 644 $(docdir)/css/*
	$(CHMOD) 644 $(docdir)/classes/html/a*.html
	$(CHMOD) 644 $(docdir)/classes/html/b*.html
	$(CHMOD) 644 $(docdir)/classes/html/c*.html
	$(CHMOD) 644 $(docdir)/classes/html/d*.html
	$(CHMOD) 644 $(docdir)/classes/html/e*.html
	$(CHMOD) 644 $(docdir)/classes/html/f*.html
	$(CHMOD) 644 $(docdir)/classes/html/g*.html
	$(CHMOD) 644 $(docdir)/classes/html/h*.html
	$(CHMOD) 644 $(docdir)/classes/html/i*.html
	$(CHMOD) 644 $(docdir)/classes/html/l*.html
	$(CHMOD) 644 $(docdir)/classes/html/m*.html
	$(CHMOD) 644 $(docdir)/classes/html/n*.html
	$(CHMOD) 644 $(docdir)/classes/html/p*.html
	$(CHMOD) 644 $(docdir)/classes/html/r*.html
	$(CHMOD) 644 $(docdir)/classes/html/s*.html
	$(CHMOD) 644 $(docdir)/classes/html/t*.html
	$(CHMOD) 644 $(docdir)/classes/html/u*.html
	$(CHMOD) 644 $(docdir)/classes/html/w*.html
	$(CHMOD) 644 $(docdir)/classes/html/x*.html
	$(CHMOD) 644 $(docdir)/classes/html/*.png
	$(CHMOD) 644 $(docdir)/classes/html/*.css
	$(CHMOD) 644 $(docdir)/classes/html/*.js
	$(CHMOD) 644 $(docdir)/features/*.html
	$(CHMOD) 644 $(docdir)/programming/*.html
	$(CHMOD) 644 $(docdir)/images/*

uninstall:
	$(RMTREE) $(docdir)

=== examples/Makefile ===
top_builddir = ..

include ../config.mk

CPPFLAGS = $(BASECPPFLAGS) $(INC)../ $(INC)../include
LIBS=$(RUDIMENTSLIB) $(SOCKETLIBS) $(PTHREADLIB) $(LIBEDITLIBS) $(SSLLIBS) $(GSSLIBS) $(PCRELIBS) $(LIBCURLLIBS) $(NANOSLEEPLIB) $(CLOCKNANOSLEEPLIB) $(CRYPTLIB) $(INETATONLIB) $(BELIB) $(GNULIB) $(CRTLIB) $(DLLIB) $(GETPGIDLIB) $(DEBUGLIB)

PROGS0 = \
	character-isxxx$(EXE) \
	character-toxxx$(EXE) \
	character-inset$(EXE) \
	charstring-copy$(EXE) \
	charstring-compare$(EXE) \
	charstring-find$(EXE) \
	charstring-transform$(EXE) \
	charstring-split$(EXE) \
	charstring-numbers$(EXE) \
	charstring-encode$(EXE) \
	chat$(EXE) \
	commandline$(EXE) \
	complexinetsocketserver$(EXE) \
	crypt$(EXE) \
	datetime-basic$(EXE) \
	datetime-init$(EXE) \
	datetime-math$(EXE) \
	datetime-tz$(EXE) \
	device$(EXE) \
	dictionary-const$(EXE) \
	dictionary-nonconst$(EXE) \
	directory$(EXE) \
	dynamiclib$(EXE) \
	environment$(EXE) \
	error$(EXE) \
	file-create$(EXE) \
	file-remove$(EXE) \
	file-open$(EXE) \
	file-getprops$(EXE) \
	file-read$(EXE) \
	cat$(EXE) \
	file-readline$(EXE) \
	file-write$(EXE) \
	file-random$(EXE) \
	file-lock$(EXE) \
	file-truncate$(EXE) \
	file-buffers$(EXE) \
	file-optimizations$(EXE) \
	file-temp$(EXE) \
	file-links$(EXE) \
	file-fifos$(EXE) \
	file-pipes$(EXE) \
	file-convenience$(EXE) \
	filesystem$(EXE) \
	groupentry$(EXE) \
	hostentry-hostname$(EXE) \
	hostentry-address$(EXE) \
	inetsocketclient$(EXE) \
	inetsocketserver$(EXE)

PROGS1 = \
	linkedlist-values$(EXE) \
	linkedlist-nodes$(EXE) \
	linkedlist-sort$(EXE) \
	linkedlist-iterate$(EXE) \
	linkedlist-types$(EXE) \
	listener$(EXE) \
	logger$(EXE) \
	memorymap$(EXE) \
	memorypool$(EXE) \
	modemclient$(EXE) \
	modemserver$(EXE) \
	thread-join$(EXE) \
	thread-detach$(EXE) \
	threadmutex$(EXE) \
	parameterstring$(EXE) \
	userentry$(EXE) \
	permissions$(EXE) \
	process-info$(EXE) \
	process-exit$(EXE) \
	process-atexit$(EXE) \
	process-exitimmediately$(EXE) \
	process-exitoncrash$(EXE) \
	process-handlecrash$(EXE) \
	process-exitonshutdown$(EXE) \
	process-handleshutdown$(EXE) \
	process-setuidgid$(EXE) \
	process-seteuidgid$(EXE) \
	process-spawn$(EXE) \
	process-fork$(EXE) \
	process-forkexec$(EXE) \
	process-zombie$(EXE) \
	process-detach$(EXE) \
	protocolentry-name$(EXE) \
	protocolentry-number$(EXE) \
	randomnumber-static$(EXE) \
	randomnumber-multiple$(EXE) \
	bytestring-copy$(EXE) \
	bytestring-compare$(EXE) \
	bytestring-find$(EXE) \
	regularexpression-static$(EXE) \
	regularexpression-compile$(EXE) \
	regularexpression-multiple$(EXE) \
	serialport$(EXE) \
	serialportprofile$(EXE)

PROGS2 = \
	serviceentry-name$(EXE) \
	serviceentry-number$(EXE) \
	sharedmemory1$(EXE) \
	sharedmemory2$(EXE) \
	semaphoreset1$(EXE) \
	semaphoreset2$(EXE) \
	signal$(EXE) \
	kill$(EXE) \
	singlylinkedlist-values$(EXE) \
	singlylinkedlist-nodes$(EXE) \
	singlylinkedlist-sort$(EXE) \
	singlylinkedlist-iterate$(EXE) \
	singlylinkedlist-types$(EXE) \
	snooze$(EXE) \
	stdio$(EXE) \
	stringbuffer$(EXE) \
	sys$(EXE) \
	reboot$(EXE) \
	shutdown$(EXE) \
	halt$(EXE) \
	unixsocketclient$(EXE) \
	unixsocketserver$(EXE) \
	bytebuffer$(EXE) \
	xmldom$(EXE) \
	xmlsax$(EXE) \
	codetree$(EXE) \
	compiler$(EXE) \
	avltree$(EXE) \
	hash$(EXE) \
	gss$(EXE) \
	tls$(EXE)
	

PROGS = $(PROGS0) $(PROGS1) $(PROGS2)

.SUFFIXES: .lo .obj

.cpp.lo:
	$(LTCOMPILE) $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $< $(OUT)$@

.cpp.obj:
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $<

all: $(PROGS)

clean:
	$(LTCLEAN) $(RM) $(PROGS0)
	$(LTCLEAN) $(RM) $(PROGS1)
	$(LTCLEAN) $(RM) $(PROGS2)
	$(LTCLEAN) $(RM) *.lo *.o *.obj shm sem testfile testfile1 testfile2 *.ii

character-isxxx$(EXE): character-isxxx.cpp character-isxxx.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ character-isxxx.$(OBJ) $(LIBS)

character-toxxx$(EXE): character-toxxx.cpp character-toxxx.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ character-toxxx.$(OBJ) $(LIBS)

character-inset$(EXE): character-inset.cpp character-inset.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ character-inset.$(OBJ) $(LIBS)

charstring-copy$(EXE): charstring-copy.cpp charstring-copy.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-copy.$(OBJ) $(LIBS)

charstring-compare$(EXE): charstring-compare.cpp charstring-compare.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-compare.$(OBJ) $(LIBS)

charstring-find$(EXE): charstring-find.cpp charstring-find.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-find.$(OBJ) $(LIBS)

charstring-transform$(EXE): charstring-transform.cpp charstring-transform.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-transform.$(OBJ) $(LIBS)

charstring-split$(EXE): charstring-split.cpp charstring-split.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-split.$(OBJ) $(LIBS)

charstring-numbers$(EXE): charstring-numbers.cpp charstring-numbers.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-numbers.$(OBJ) $(LIBS)

charstring-encode$(EXE): charstring-encode.cpp charstring-encode.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ charstring-encode.$(OBJ) $(LIBS)

chat$(EXE): chat.cpp chat.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ chat.$(OBJ) $(LIBS)

clientserverfactory$(EXE): clientserverfactory.cpp clientserverfactory.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ clientserverfactory.$(OBJ) $(LIBS)

commandline$(EXE): commandline.cpp commandline.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ commandline.$(OBJ) $(LIBS)

complexinetsocketserver$(EXE): complexinetsocketserver.cpp complexinetsocketserver.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ complexinetsocketserver.$(OBJ) $(LIBS)

crypt$(EXE): crypt.cpp crypt.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ crypt.$(OBJ) $(LIBS)

datetime-basic$(EXE): datetime-basic.cpp datetime-basic.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ datetime-basic.$(OBJ) $(LIBS)

datetime-init$(EXE): datetime-init.cpp datetime-init.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ datetime-init.$(OBJ) $(LIBS)

datetime-math$(EXE): datetime-math.cpp datetime-math.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ datetime-math.$(OBJ) $(LIBS)

datetime-tz$(EXE): datetime-tz.cpp datetime-tz.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ datetime-tz.$(OBJ) $(LIBS)

device$(EXE): device.cpp device.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ device.$(OBJ) $(LIBS)

dictionary-const$(EXE): dictionary-const.cpp dictionary-const.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ dictionary-const.$(OBJ) $(LIBS)

dictionary-nonconst$(EXE): dictionary-nonconst.cpp dictionary-nonconst.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ dictionary-nonconst.$(OBJ) $(LIBS)

directory$(EXE): directory.cpp directory.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ directory.$(OBJ) $(LIBS)

dynamiclib$(EXE): dynamiclib.cpp dynamiclib.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ dynamiclib.$(OBJ) $(LIBS)

environment$(EXE): environment.cpp environment.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ environment.$(OBJ) $(LIBS)

error$(EXE): error.cpp error.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ error.$(OBJ) $(LIBS)

file-create$(EXE): file-create.cpp file-create.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-create.$(OBJ) $(LIBS)

file-remove$(EXE): file-remove.cpp file-remove.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-remove.$(OBJ) $(LIBS)

file-open$(EXE): file-open.cpp file-open.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-open.$(OBJ) $(LIBS)

file-getprops$(EXE): file-getprops.cpp file-getprops.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-getprops.$(OBJ) $(LIBS)

file-read$(EXE): file-read.cpp file-read.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-read.$(OBJ) $(LIBS)

cat$(EXE): cat.cpp cat.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ cat.$(OBJ) $(LIBS)

file-readline$(EXE): file-readline.cpp file-readline.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-readline.$(OBJ) $(LIBS)

file-write$(EXE): file-write.cpp file-write.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-write.$(OBJ) $(LIBS)

file-random$(EXE): file-random.cpp file-random.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-random.$(OBJ) $(LIBS)

file-lock$(EXE): file-lock.cpp file-lock.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-lock.$(OBJ) $(LIBS)

file-truncate$(EXE): file-truncate.cpp file-truncate.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-truncate.$(OBJ) $(LIBS)

file-buffers$(EXE): file-buffers.cpp file-buffers.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-buffers.$(OBJ) $(LIBS)

file-optimizations$(EXE): file-optimizations.cpp file-optimizations.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-optimizations.$(OBJ) $(LIBS)

file-temp$(EXE): file-temp.cpp file-temp.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-temp.$(OBJ) $(LIBS)

file-links$(EXE): file-links.cpp file-links.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-links.$(OBJ) $(LIBS)

file-fifos$(EXE): file-fifos.cpp file-fifos.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-fifos.$(OBJ) $(LIBS)

file-pipes$(EXE): file-pipes.cpp file-pipes.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-pipes.$(OBJ) $(LIBS)

file-convenience$(EXE): file-convenience.cpp file-convenience.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ file-convenience.$(OBJ) $(LIBS)

filesystem$(EXE): filesystem.cpp filesystem.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ filesystem.$(OBJ) $(LIBS)

groupentry$(EXE): groupentry.cpp groupentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ groupentry.$(OBJ) $(LIBS)

hostentry-hostname$(EXE): hostentry-hostname.cpp hostentry-hostname.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ hostentry-hostname.$(OBJ) $(LIBS)

hostentry-address$(EXE): hostentry-address.cpp hostentry-address.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ hostentry-address.$(OBJ) $(LIBS)

inetsocketclient$(EXE): inetsocketclient.cpp inetsocketclient.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ inetsocketclient.$(OBJ) $(LIBS)

inetsocketserver$(EXE): inetsocketserver.cpp inetsocketserver.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ inetsocketserver.$(OBJ) $(LIBS)

linkedlist-values$(EXE): linkedlist-values.cpp linkedlist-values.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ linkedlist-values.$(OBJ) $(LIBS)

linkedlist-nodes$(EXE): linkedlist-nodes.cpp linkedlist-nodes.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ linkedlist-nodes.$(OBJ) $(LIBS)

linkedlist-sort$(EXE): linkedlist-sort.cpp linkedlist-sort.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ linkedlist-sort.$(OBJ) $(LIBS)

linkedlist-iterate$(EXE): linkedlist-iterate.cpp linkedlist-iterate.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ linkedlist-iterate.$(OBJ) $(LIBS)

linkedlist-types$(EXE): linkedlist-types.cpp linkedlist-types.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ linkedlist-types.$(OBJ) $(LIBS)

listener$(EXE): listener.cpp listener.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ listener.$(OBJ) $(LIBS)

logger$(EXE): logger.cpp logger.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ logger.$(OBJ) $(LIBS)

memorymap$(EXE): memorymap.cpp memorymap.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ memorymap.$(OBJ) $(LIBS)

memorypool$(EXE): memorypool.cpp memorypool.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ memorypool.$(OBJ) $(LIBS)

modemclient$(EXE): modemclient.cpp modemclient.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ modemclient.$(OBJ) $(LIBS)

modemserver$(EXE): modemserver.cpp modemserver.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ modemserver.$(OBJ) $(LIBS)

thread-join$(EXE): thread-join.cpp thread-join.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ thread-join.$(OBJ) $(LIBS)

thread-detach$(EXE): thread-detach.cpp thread-detach.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ thread-detach.$(OBJ) $(LIBS)

threadmutex$(EXE): threadmutex.cpp threadmutex.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ threadmutex.$(OBJ) $(LIBS)

parameterstring$(EXE): parameterstring.cpp parameterstring.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ parameterstring.$(OBJ) $(LIBS)

userentry$(EXE): userentry.cpp userentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ userentry.$(OBJ) $(LIBS)

permissions$(EXE): permissions.cpp permissions.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ permissions.$(OBJ) $(LIBS)

process-info$(EXE): process-info.cpp process-info.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ process-info.$(OBJ) $(LIBS)

process-exit$(EXE): process-exit.cpp process-exit.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ process-exit.$(OBJ) $(LIBS)

process-atexit$(EXE): process-atexit.cpp process-atexit.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ process-atexit.$(OBJ) $(LIBS)

process-exitimmediately$(EXE): process-exitimmediately.cpp process-exitimmediately.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@ process-exitimmediately.$(OBJ) $(LIBS)

=== man/Makefile ===
top_builddir = ..

include ../config.mk

install:
	$(MKINSTALLDIRS) $(mandir)
	$(MKINSTALLDIRS) $(mandir)/man1
	$(CP) rudiments-config.1 $(mandir)/man1
	$(CHMOD) 644 $(mandir)/man1/rudiments-config.1

uninstall:
	$(RM) $(mandir)/man1/rudiments-config.1

=== test/Makefile ===
top_builddir = ..

include ../config.mk

CPPFLAGS = $(BASECPPFLAGS) $(INC)../ $(INC)../include
LIBS=$(RUDIMENTSLIB) $(SOCKETLIBS) $(PTHREADLIB) $(LIBEDITLIBS) $(SSLLIBS) $(GSSLIBS) $(PCRELIBS) $(LIBCURLLIBS) $(NANOSLEEPLIB) $(CLOCKNANOSLEEPLIB) $(CRYPTLIB) $(INETATONLIB) $(BELIB) $(GNULIB) $(CRTLIB) $(DLLIB) $(GETPGIDLIB) $(DEBUGLIB)

PROGS0 = listener \
	directory \
	groupentry \
	commandline \
	parameterstring \
	hostentry \
	userentry \
	serviceentry \
	permissions \
	protocolentry \
	regularexpression \
	semaphoreset \
	charstring \
	wcharstring \
	datetime

PROGS1= dictionary \
	environment \
	file \
	filesystem \
	linkedlist \
	avltree \
	singlylinkedlist \
	listmetrics \
	memorypool \
	randomnumber \
	sharedmemory \
	signal \
	kill \
	stringbuffer \
	wstringbuffer \
	bytebuffer \
	crypt

PROGS2= dynamicarray \
	staticarray \
	dynamiclib \
	error \
	thread \
	threadmutex \
	process \
	snooze \
	memorymap \
	character \
	wcharacter \
	bytestring \
	tlsserver \
	tlsclient

PROGS3= handoff \
	xmldom \
	logger \
	sys \
	reboot \
	halt \
	shutdown \
	url \
	gssserver \
	gssclient \
	md5sum \
	csvdom \
	jsondom \
	cgi.cgi \
	headers.cgi \
	multipart.cgi \
	pr.cgi \
	inidom \
	propdom \
	mvcproperties \
	aes128

PROGS = $(PROGS0) $(PROGS1) $(PROGS2) $(PROGS3)

#ALLSTATIC=-all-static 

.SUFFIXES: .lo .obj

.cpp.lo:
	$(LTCOMPILE) $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $< $(OUT)$@

.cpp.obj:
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(COMPILE) $<

all: $(PROGS) $(SERVERPEM)

tests: all
	$(SCRIPTINT) $(THISDIR)testall$(SCRIPTEXT)
	
clean:
	$(LTCLEAN) $(RM) $(PROGS0)
	$(LTCLEAN) $(RM) $(PROGS1)
	$(LTCLEAN) $(RM) $(PROGS2)
	$(LTCLEAN) $(RM) $(PROGS3)
	$(LTCLEAN) $(RM) *.exe *.ilk *.idb *.pdb *.manifest *.lo *.o *.obj test.log testfile *.pem *.pfx *.xml *.sck *.ii *.csv *.json *.ini .prop handofffile *.cgi app1/app2/*.cgi semout semkey
	cd certificates $(AND) $(MAKE) clean

tlsserver: tlsserver.cpp tlsserver.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) tlsserver.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

listener: listener.cpp listener.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) listener.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

tlsclient: tlsclient.cpp tlsclient.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) tlsclient.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

directory: directory.cpp directory.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) directory.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

commandline: commandline.cpp commandline.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) commandline.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

parameterstring: parameterstring.cpp parameterstring.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) parameterstring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

logger: logger.cpp logger.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) logger.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

environment: environment.cpp environment.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) environment.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

file: file.cpp file.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) file.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

filesystem: filesystem.cpp filesystem.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) filesystem.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

groupentry: groupentry.cpp groupentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) groupentry.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

hostentry: hostentry.cpp hostentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) hostentry.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

linkedlist: linkedlist.cpp linkedlist.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) linkedlist.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

avltree: avltree.cpp avltree.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) avltree.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

singlylinkedlist: singlylinkedlist.cpp singlylinkedlist.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) singlylinkedlist.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

listmetrics: listmetrics.cpp listmetrics.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) listmetrics.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

memorypool: memorypool.cpp memorypool.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) memorypool.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

userentry: userentry.cpp userentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) userentry.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

serviceentry: serviceentry.cpp serviceentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) serviceentry.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

permissions: permissions.cpp permissions.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) permissions.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

protocolentry: protocolentry.cpp protocolentry.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) protocolentry.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

regularexpression: regularexpression.cpp regularexpression.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) regularexpression.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

semaphoreset: semaphoreset.cpp semaphoreset.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) semaphoreset.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

sharedmemory: sharedmemory.cpp sharedmemory.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) sharedmemory.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

charstring: charstring.cpp charstring.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) charstring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

wcharstring: wcharstring.cpp wcharstring.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) wcharstring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

datetime: datetime.cpp datetime.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) datetime.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

dictionary: dictionary.cpp dictionary.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) dictionary.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

randomnumber: randomnumber.cpp randomnumber.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) randomnumber.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

signal: signal.cpp signal.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) signal.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

kill: kill.cpp kill.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) kill.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

stringbuffer: stringbuffer.cpp stringbuffer.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) stringbuffer.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

wstringbuffer: wstringbuffer.cpp wstringbuffer.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) wstringbuffer.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

handoff: handoff.cpp handoff.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) handoff.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

bytebuffer: bytebuffer.cpp bytebuffer.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) bytebuffer.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

xmldom: xmldom.cpp xmldom.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) xmldom.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

crypt: crypt.cpp crypt.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) crypt.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

dynamicarray: dynamicarray.cpp dynamicarray.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) dynamicarray.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

staticarray: staticarray.cpp staticarray.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) staticarray.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

dynamiclib: dynamiclib.cpp dynamiclib.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) dynamiclib.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

error: error.cpp error.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) error.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

thread: thread.cpp thread.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) thread.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

threadmutex: threadmutex.cpp threadmutex.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) threadmutex.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

process: process.cpp process.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) process.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

snooze: snooze.cpp snooze.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) snooze.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

memorymap: memorymap.cpp memorymap.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) memorymap.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

character: character.cpp character.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) character.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

wcharacter: wcharacter.cpp wcharacter.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) wcharacter.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

bytestring: bytestring.cpp bytestring.$(OBJ) 
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) bytestring.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

sys: sys.cpp sys.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) sys.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

reboot: reboot.cpp reboot.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) reboot.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

halt: halt.cpp halt.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) halt.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

shutdown: shutdown.cpp shutdown.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) shutdown.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

url: url.cpp url.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) url.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

gssserver: gssserver.cpp gssserver.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) gssserver.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

gssclient: gssclient.cpp gssclient.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) gssclient.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

md5sum: md5sum.cpp md5sum.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) md5sum.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

csvdom: csvdom.cpp csvdom.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) csvdom.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

jsondom: jsondom.cpp jsondom.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) jsondom.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

cgi.cgi: cgi.cpp cgi.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) cgi.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

headers.cgi: headers.cpp headers.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) headers.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

multipart.cgi: multipart.cpp multipart.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) multipart.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

pr.cgi: pr.cpp pr.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) pr.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)
	$(CP) -f $@ app1/app2

inidom: inidom.cpp inidom.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) inidom.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

propdom: propdom.cpp propdom.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) propdom.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

mvcproperties: mvcproperties.cpp mvcproperties.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) mvcproperties.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

aes128: aes128.cpp aes128.$(OBJ)
	$(LTLINK) $(LINK) $(OUT)$@$(EXE) aes128.$(OBJ) $(ALLSTATIC) $(LDFLAGS) $(LIBS)

server.pem:
	cd certificates $(AND) $(MAKE) clean all
	cp certificates/certificatechains/ca.pem .
	cp certificates/certificatechains/server.pem .
	cp certificates/certificatechains/client.pem .
	cp certificates/certificatechains/ca.pfx .
	cp certificates/certificatechains/server.pfx .
	cp certificates/certificatechains/client.pfx .

=== test/certificates/Makefile ===
include ../../config.mk

all: certificatechains/ca.pfx certificatechains/client.pfx certificatechains/server.pfx certificatechains/db.pfx

clean:
	cd keys $(AND) $(RM) *.key
	cd requests $(AND) $(RM) *.csr
	cd certificates $(AND) $(RM) *.crt *.pfx
	cd database $(AND) $(RM) index* serial*
	cd database $(AND) cd newcerts $(AND) $(RM) *.pem
	cd certificatechains $(AND) $(RM) *.pem
	cd certificatechains $(AND) $(RM) *.pfx

database/index.txt:
	touch database/index.txt

database/serial: database/index.txt
	echo '01' > database/serial

keys/ca.key: database/serial
	$(OPENSSL) genrsa -out keys/ca.key; \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) genrsa -rand /etc/passwd -out keys/ca.key; \
	fi

certificates/ca.crt: keys/ca.key
	$(OPENSSL) req -config config/ca.cnf -new -x509 -days 3650 -key keys/ca.key -out certificates/ca.crt

certificatechains/ca.pem: certificates/ca.crt
	cat certificates/ca.crt > certificatechains/ca.pem

certificatechains/ca.pfx: certificatechains/ca.pem
	PASSWORD="" $(OPENSSL) pkcs12 -export -passout env:PASSWORD -in certificates/ca.crt -inkey keys/ca.key -out certificatechains/ca.pfx

keys/client.key:
	$(OPENSSL) genrsa -out keys/client.key || \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) genrsa -rand /etc/passwd -out keys/client.key; \
	fi

requests/client.csr: keys/client.key
	$(OPENSSL) req -config config/client.cnf -new -key keys/client.key -out requests/client.csr

certificates/client.crt: requests/client.csr certificates/ca.crt
	$(OPENSSL) ca -batch -config config/ca.cnf -in requests/client.csr -out certificates/client.crt -extfile config/client.ca.cnf; \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) ca -batch -config config/ca.cnf -in requests/client.csr -out certificates/client.crt; \
	fi

certificatechains/client.pem: certificates/client.crt
	cat certificates/client.crt > certificatechains/client.pem
	cat keys/client.key >> certificatechains/client.pem
	cat certificates/ca.crt >> certificatechains/client.pem

certificatechains/client.pfx: certificatechains/client.pem
	PASSWORD="" $(OPENSSL) pkcs12 -export -passout env:PASSWORD -in certificates/client.crt -inkey keys/client.key -certfile certificates/ca.crt -out certificatechains/client.pfx

keys/server.key:
	$(OPENSSL) genrsa -out keys/server.key || \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) genrsa -rand /etc/passwd -out keys/server.key; \
	fi

requests/server.csr: keys/server.key certificates/ca.crt
	$(OPENSSL) req -config config/server.cnf -new -key keys/server.key -out requests/server.csr

certificates/server.crt: requests/server.csr
	$(OPENSSL) ca -batch -config config/ca.cnf -in requests/server.csr -out certificates/server.crt -extfile config/server.ca.cnf; \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) ca -batch -config config/ca.cnf -in requests/server.csr -out certificates/server.crt; \
	fi

certificatechains/server.pem: certificates/server.crt
	cat certificates/server.crt > certificatechains/server.pem
	cat keys/server.key >> certificatechains/server.pem
	cat certificates/ca.crt >> certificatechains/server.pem

certificatechains/server.pfx: certificatechains/server.pem
	PASSWORD="" $(OPENSSL) pkcs12 -export -passout env:PASSWORD -in certificates/server.crt -inkey keys/server.key -certfile certificates/ca.crt -out certificatechains/server.pfx

keys/db.key:
	$(OPENSSL) genrsa -out keys/db.key || \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) genrsa -rand /etc/passwd -out keys/db.key; \
	fi

requests/db.csr: keys/db.key certificates/ca.crt
	$(OPENSSL) req -config config/db.cnf -new -key keys/db.key -out requests/db.csr

certificates/db.crt: requests/db.csr
	$(OPENSSL) ca -batch -config config/ca.cnf -in requests/db.csr -out certificates/db.crt -extfile config/db.ca.cnf; \
	if ( test "$$?" = "1" ); \
	then \
		$(OPENSSL) ca -batch -config config/ca.cnf -in requests/db.csr -out certificates/db.crt; \
	fi

certificatechains/db.pem: certificates/db.crt
	cat certificates/db.crt > certificatechains/db.pem
	cat keys/db.key >> certificatechains/db.pem
	cat certificates/ca.crt >> certificatechains/db.pem

certificatechains/db.pfx: certificatechains/db.pem
	PASSWORD="" $(OPENSSL) pkcs12 -export -passout env:PASSWORD -in certificates/db.crt -inkey keys/db.key -certfile certificates/ca.crt -out certificatechains/db.pfx

=== debian/changelog ===
rudiments (1.4.2-1) unstable; urgency=medium

  * Initial release

 -- David Muse <david.muse@firstworks.com>  Thu, 03 Jan 2019 20:32:59 -0500

=== debian/control ===
Source: rudiments
Priority: optional
Maintainer: David Muse <david.muse@firstworks.com>
Homepage: http://rudiments.sourceforge.net
Standards-Version: 3.9.6
Build-Depends: debhelper (>=9),autotools-dev, libedit-dev, libssl-dev, libcurl4-openssl-dev, libkrb5-dev

Package: rudiments
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libedit2, openssl, libcurl4, libkrb5-3
Description: C++ class library for developing systems and applications
 A C++ class library for developing systems and applications.  Rudiments
 includes frameworks for processes, threads, clients, servers, loggers and
 compilers.  It also includes data structures for buffers, arrays, linked lists
 and dictionaries, and utility classes for processing text and binary data,
 regular expressions, random numbers, encryption, date and time, system
 information, files, directories, file-systems, inter-process communication,
 dynamic libraries, and XML.

Package: rudiments-dev
Section: libdevel
Architecture: any
Depends: rudiments (= ${binary:Version}), ${misc:Depends}
Description: Development files for rudiments
 Development files for rudiments.

Package: rudiments-doc
Section: libs
Architecture: any
Depends: ${misc:Depends}
Description: Documentation for rudiments
 Documentation for rudiments.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	DISTBUILDDEPENDS = -Vdist:BuildDepends="libssl-dev"
else
	DISTBUILDDEPENDS = -Vdist:BuildDepends="libssl1.0-dev"
endif


clean:
	dh_testdir
	dh_auto_configure
	dh_auto_clean
	dh_clean

%:
	dh $@  --with autotools_dev
